Index: /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/Diffuse.material
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/Diffuse.material	(revision 1671)
+++ /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/Diffuse.material	(revision 1735)
@@ -101,5 +101,5 @@
 	source GameTools_Diffuse.hlsl
 	entry_point DiffuseVS
-	target vs_3_0
+	target vs_3_0	
 } 
 
@@ -109,4 +109,5 @@
 	entry_point DiffusePS
 	target ps_3_0
+	flow_control prefer
 } 
 
@@ -122,4 +123,5 @@
 		IllumTechniques
 		{
+			
 			RenderTechnique DistanceCubeMap
 			{
Index: /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/MetalTeapot.material
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/MetalTeapot.material	(revision 1730)
+++ /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/MetalTeapot.material	(revision 1735)
@@ -122,5 +122,5 @@
 	entry_point MetalMultipleBouncePS
 	target ps_3_0
-	flow_control avoid
+	flow_control prefer
 } 
 
@@ -135,5 +135,6 @@
 			RenderTechnique ColorCubeMap
 			{
-				update_interval		1
+				resolution 1024
+				update_interval		0
 				distance_calc false
 				face_angle_calc false
@@ -142,16 +143,18 @@
 			RenderTechnique DistanceCubeMap
 			{
-				update_interval		1
-				distance_calc true false
-				face_angle_calc true false
+				resolution 1024
+				update_interval		0
+				distance_calc false
+				face_angle_calc false
 				update_all_face true
 			}
 			RenderTechnique ColorCubeMap
 			{
+				resolution 1024
 				layer 1
 				texture_unit_id 2
-				update_interval		1
-				distance_calc true false
-				face_angle_calc true false
+				update_interval		0
+				distance_calc false
+				face_angle_calc false
 				update_all_face true
 				render_env false
@@ -161,9 +164,10 @@
 			RenderTechnique ColorCubeMap
 			{
+				resolution 1024
 				layer 2
 				texture_unit_id 3
-				update_interval		1
-				distance_calc true false
-				face_angle_calc true false
+				update_interval		0
+				distance_calc false
+				face_angle_calc false
 				update_all_face true
 				render_env false
@@ -192,10 +196,10 @@
 		texture_unit
 		{
-			
+			//filtering none
 		}
 		//Cube map of environment distances
 		texture_unit
 		{
-			
+			filtering none
 		}
 		
@@ -203,5 +207,5 @@
 		texture_unit
 		{
-			
+			filtering none
 		}
 		
@@ -209,5 +213,5 @@
 		texture_unit
 		{
-			
+			filtering none
 		}
 	  }
Index: /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/programs/MetalTeapot.hlsl
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/programs/MetalTeapot.hlsl	(revision 1730)
+++ /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/programs/MetalTeapot.hlsl	(revision 1735)
@@ -3,5 +3,5 @@
 float4 readCubeMap(samplerCUBE cm, float3 coord)		
 {
-	float4 color = texCUBE( cm, float3(coord.xy, - coord.z) );
+	float4 color = texCUBElod( cm, float4(coord.xy, - coord.z,0) );
 	return color;
 }
@@ -9,5 +9,5 @@
 float readDistanceCubeMap(samplerCUBE dcm, float3 coord)		
 {
-	float dist = texCUBE(dcm, float3(coord.xy, - coord.z)).a;
+	float dist = texCUBElod(dcm, float4(coord.xy, - coord.z,0)).a;
 	return dist;
 }
@@ -15,5 +15,5 @@
 
 
-#define LIN_ITERATIONCOUNT 2
+#define LIN_ITERATIONCOUNT 20
 #define SECANT_ITERATIONCOUNT 2
 
@@ -24,17 +24,35 @@
 	float3 Ra = abs(R);
 	float3 xa = abs(x);
-	float a = max(max(xa.x,xa.y),xa.z) / 
-			  max(max(Ra.x,Ra.y),Ra.z);
-	
-	bool overshoot = false, undershoot = false;
+	
+    float xm =  max(max(xa.x,xa.y),xa.z);
+    float Rm = max(max(Ra.x,Ra.y),Ra.z);
+    
+    float a = xm / Rm;
+    
+  
+    float dt =  length(x / xm - R / Rm) * 256.0 / 2.0;
+    dt = max(dt, 4);
+    dt = 1.0 / dt;
+    
+    	
+	bool overshoot = false, undershoot = true;
 	float dp, dl = 0, ppp, llp;
 	float lR = readDistanceCubeMap(mp, R);
 	//float3 p = R;
 	float3 p = 0;
-		
-	float dt = 1.0 / LIN_ITERATIONCOUNT;
+	
+	
+	//float dt = 1.0 / LIN_ITERATIONCOUNT;
 	
 	//linear iteration	
-	float t = 0;
+	
+	float t = 0.9999999999999;
+	dp = a * t / (1 - t);
+	p = x + R * dp;
+	float dist = readDistanceCubeMap(mp, p);
+	ppp = length(p) / dist;
+	
+	t = 0;	
+		
 	while(t < 1.0 && !overshoot)
 	{
@@ -63,13 +81,6 @@
 	}
 	
-	if(t >= 1 && undershoot)
-	{
-		t = 0.9999999999999;
-		dp = a * t / (1 - t);
-		p = x + R * dp;
-		float dist = readDistanceCubeMap(mp, p);
-		ppp = length(p) / dist;
-		overshoot = true;
-	}
+	if(t >= 1.0 && undershoot && dist)
+		overshoot = true;	
 	
 	if(overshoot)
@@ -102,5 +113,5 @@
 			
 /*
-float3 Hit( float3 x, float3 R, samplerCUBE mp )
+float Hit( float3 x, float3 R, samplerCUBE mp, out float3 newDir )
 {
 	//return R  + 0.00000000001 * x;
@@ -128,5 +139,7 @@
 		l = x + R * dl;										// ray equation
 	}
-	return l;												// computed hit point
+	newDir = l;												// computed hit point
+	
+	return dl;
 }
 */
Index: /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/programs/GameTools_Diffuse.hlsl
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/programs/GameTools_Diffuse.hlsl	(revision 1683)
+++ /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/programs/GameTools_Diffuse.hlsl	(revision 1735)
@@ -3,5 +3,5 @@
 float4 readCubeMap(samplerCUBE cm, float3 coord)		
 {
-	float4 color = texCUBE( cm, float3(coord.xy, -coord.z) );
+	float4 color = texCUBElod( cm, float4(coord.xy, -coord.z, 1) );
 	color.a = 1;
 	return color;
@@ -10,37 +10,9 @@
 float readDistanceCubeMap(samplerCUBE dcm, float3 coord)		
 {
-	float dist = texCUBE(dcm, float3(coord.xy, - coord.z)).r;
+	float dist = texCUBElod(dcm, float4(coord.xy, - coord.z, 1)).r;
 	if(dist == 0) dist = 1000000; ///sky
 	return dist;
 }
 
-// This function is called several times.
-float3 Hit( float3 x, float3 R, samplerCUBE mp )
-{
-	float rl = readDistanceCubeMap( mp, R);				// |r|
-	
-	float ppp = length( x ) /  readDistanceCubeMap( mp, x);			// |p|/|p|
-	float dun = 0, pun = ppp, dov = 0, pov = 0;
-	float dl = rl * ( 1 - ppp );							// eq. 2
-	float3 l = x + R * dl;									// ray equation
-
-	// iteration
-	for( int i = 0; i < 2; i++ )	// 2 !!!!!!!!!!!!!!!!!!!!!!!
-	{
-		float llp = length( l ) / readDistanceCubeMap( mp, l);		// |l|/|l|
-		if ( llp < 0.999f )									// undershooting
-		{
-			dun = dl; pun = llp;							// last undershooting
-			dl += ( dov == 0 ) ? rl * ( 1 - llp ) :			// eq. 2
-				( dl - dov ) * ( 1 - llp ) / ( llp - pov );	// eq. 3
-		} else if ( llp > 1.001f )							// overshooting
-		{
-			dov = dl; pov = llp;							// last overshooting
-			dl += ( dl -dun ) * ( 1 - llp ) / ( llp - pun );// eq. 3
-		}
-		l = x + R * dl;										// ray equation
-	}
-	return l;												// computed hit point
-}
 
 /////////////////////
Index: /GTP/trunk/App/Demos/Illum/Ogre/src/ReflectionTest/include/ReflectionTest.h
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/src/ReflectionTest/include/ReflectionTest.h	(revision 1724)
+++ /GTP/trunk/App/Demos/Illum/Ogre/src/ReflectionTest/include/ReflectionTest.h	(revision 1735)
@@ -42,5 +42,5 @@
 				 
     {
-		this->mMoveSpeed = 2.0;
+		this->mMoveSpeed = 0.5;
 		framecount = 0;		
 		this->objectNode = objectNode;
Index: /GTP/trunk/App/Demos/Illum/Ogre/bin/Release/ogre.cfg
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/bin/Release/ogre.cfg	(revision 1730)
+++ /GTP/trunk/App/Demos/Illum/Ogre/bin/Release/ogre.cfg	(revision 1735)
@@ -6,5 +6,5 @@
 Floating-point mode=Fastest
 Full Screen=No
-Rendering Device=NVIDIA GeForce 6800 GT
+Rendering Device=NVIDIA GeForce 7950 GX2
 VSync=No
 Video Mode=800 x 600 @ 32-bit colour
